# Class BasicMenuBarUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.MenuBarUI
javax.swing.plaf.basic.BasicMenuBarUI

Direct Known Subclasses:
  `MetalMenuBarUI, SynthMenuBarUI`

public class BasicMenuBarUI extends MenuBarUI
A default L&F implementation of MenuBarUI. This implementation is a "combined" view/controller.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected ChangeListener`
  `changeListener`
  The instance of `ChangeListener`.
  `protected ContainerListener`
  `containerListener`
  The instance of `ContainerListener`.
  `protected JMenuBar`
  `menuBar`
  The instance of `JMenuBar`.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BasicMenuBarUI()`
  Constructs a `BasicMenuBarUI`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected ChangeListener`
  `createChangeListener()`
  Returns an instance of `ChangeListener`.
  `protected ContainerListener`
  `createContainerListener()`
  Returns an instance of `ContainerListener`.
  `static ComponentUI`
  `createUI(JComponent x)`
  Returns a new instance of `BasicMenuBarUI`.
  `protected void`
  `installDefaults()`
  Installs default properties.
  `protected void`
  `installKeyboardActions()`
  Registers keyboard actions.
  `protected void`
  `installListeners()`
  Registers listeners.
  `protected void`
  `uninstallDefaults()`
  Uninstalls default properties.
  `protected void`
  `uninstallKeyboardActions()`
  Unregisters keyboard actions.
  `protected void`
  `uninstallListeners()`
  Unregisters listeners.

  ### Methods declared in class ComponentUI

  `contains, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getMaximumSize, getMinimumSize, getPreferredSize, installUI, paint, uninstallUI, update`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### menuBar

    protected JMenuBar menuBar
    The instance of `JMenuBar`.

  - ### containerListener

    protected ContainerListener containerListener
    The instance of `ContainerListener`.

  - ### changeListener

    protected ChangeListener changeListener
    The instance of `ChangeListener`.

- ## Constructor Details

  - ### BasicMenuBarUI

    public BasicMenuBarUI()
    Constructs a `BasicMenuBarUI`.

- ## Method Details

  - ### createUI

    public static ComponentUI createUI(JComponent x)
    Returns a new instance of `BasicMenuBarUI`.
    Parameters:
      `x` - a component
    Returns:
      a new instance of `BasicMenuBarUI`

  - ### installDefaults

    protected void installDefaults()
    Installs default properties.

  - ### installListeners

    protected void installListeners()
    Registers listeners.

  - ### installKeyboardActions

    protected void installKeyboardActions()
    Registers keyboard actions.

  - ### uninstallDefaults

    protected void uninstallDefaults()
    Uninstalls default properties.

  - ### uninstallListeners

    protected void uninstallListeners()
    Unregisters listeners.

  - ### uninstallKeyboardActions

    protected void uninstallKeyboardActions()
    Unregisters keyboard actions.

  - ### createContainerListener

    protected ContainerListener createContainerListener()
    Returns an instance of `ContainerListener`.
    Returns:
      an instance of `ContainerListener`

  - ### createChangeListener

    protected ChangeListener createChangeListener()
    Returns an instance of `ChangeListener`.
    Returns:
      an instance of `ChangeListener`